      SUBROUTINE  NAMLST
C
C     PROCESS NAMELIST STATEMENT WITH THE SYNTAX
C
C     NAMELIST /NLSNAM/ VAR1,VAR2,VAR3,...,VARN
C
C     WHERE NLSNAM IS A UNIQUE NAME, AND THE VAR'S IN THE LIST ARE
C     VARIABLE IDENTIFIERS.  THE VARIABLES ARE SUPPLIED WITH AN
C     IMPLICIT TYPE IF THEY HAVE NOT BEEN PREVIOUSLY DECLARED.
C
      INTEGER TYPVAR
      INTEGER PSTMT, STMT
      COMMON /INPUT/ NSTMT, PSTMT, STMT(1327)
      LOGICAL ERR, SYSERR, ABORT
      COMMON /DETECT/ ERR, SYSERR, ABORT
      COMMON /LETDEF/  LET0,        LET1,        LET2,        LET3
      COMMON /LETDEF/  LET4,        LET5,        LET6,        LET7
      COMMON /LETDEF/  LET8,        LET9,        LETA,        LETB
      COMMON /LETDEF/  LETC,        LETD,        LETE,        LETF
      COMMON /LETDEF/  LETG,        LETH,        LETI,        LETJ
      COMMON /LETDEF/  LETK,        LETL,        LETM,        LETN
      COMMON /LETDEF/  LETO,        LETP,        LETQ,        LETR
      COMMON /LETDEF/  LETS,        LETT,        LETU,        LETV
      COMMON /LETDEF/  LETW,        LETX,        LETY,        LETZ
      COMMON /LETDEF/  LETDOL,      LETUSC,      LETPLS,      LETMNS
      COMMON /LETDEF/  LETRP,       LETEQ,       LETDOT,      LETLP
      COMMON /LETDEF/  LETAST,      LETSLS,      LETCMA,      LETBLK
      COMMON /LETDEF/  LETSQT
C
C     ISSUE A WARNING MESSAGE THAT THE NAMELIST STATEMENT IS NOT
C     PORTABLE, BUT DO NOT SET THE ERROR FLAG.
C
      CALL ERROR1 (35H NAMELIST STATEMENT IS NOT PORTABLE,35)
C
C     PROCESSES A NAMELIST STMT
C     FIRST, PEEL OFF NAME OF NAMELIST AND SET SYMBOL TABLE ENTRY USAGE
C     CHECK NAME HAS NOT APPEARED BEFORE IN PGM UNIT
C
      IF (STMT(PSTMT) .NE. LETSLS) GO TO 40
      PSTMT = PSTMT + 1
      IF (PSTMT .GE. NSTMT) GO TO 50
      CALL NEXTOK(PSTMT, K2, L)
      IF (L .NE. 0) GO TO 30
      NAMEHD = LOOKUP(K2,.FALSE.)
      IF (SYSERR) GO TO 80
      I1 = IGATT1(NAMEHD,1)
      N = IGATT1(NAMEHD,8)
      IF ((I1 .NE. 0) .OR. (N .NE. 0)) GO TO 70
      CALL SATT1(NAMEHD, 8, 15)
      PSTMT = K2 + 1
      IF ((PSTMT .GE. NSTMT) .OR. (STMT(K2) .NE. LETSLS)) GO TO 40
      PSTMT = K2 + 1
C
C     PROCESS THE NAMELIST VARIABLE LIST
C
   10 IF (PSTMT .GE. NSTMT) GO TO 30
C
C     GET NEXT IDENTIFIER AND ITS INDEX INTO NAME TABLE.
C
      CALL NEXTOK (PSTMT, K2, L)
      IF (L .NE. 0) GO TO 30
      KK = LOOKUP(K2,.FALSE.)
      IF (SYSERR) GO TO 80
C
C     INSERT IDENTIFIER IN LINKED LIST POINTED TO BY DSA(NAMEHD+2).
C     THE LIST IS MAINTAINED IN PFORT LEXICAL ORDER.
C
      CALL INSERT (NAMEHD,KK)
      IF (SYSERR) GO TO 80
C
C     SUPPLY IMPLICIT TYPE IF VARIABLE NOT PREVIOUSLY TYPED.
C
      IF (IGATT1(KK,1) .EQ. 0) CALL SATT1 (KK, 1, TYPVAR(STMT(PSTMT)))
C
C     MAKE SURE THAT USAGE IS 'VARIABLE'.
C
      I1 = IGATT1(KK,8)
      IF ((I1 .NE. 0) .AND. (I1 .NE. 10)) GO TO 20
      IF (I1 .EQ. 0) CALL SATT1 (KK, 8, 10)
C
C     CHECK FOR END OF STMT OR COMMA
C
      IF (K2 .EQ. NSTMT) GO TO 80
      IF (STMT(K2) .NE. LETCMA) GO TO 60
      PSTMT = K2 + 1
      GO TO 10
C
C     ERROR SECTIONS AND RETURN.
C
   20 CALL ERROR1(32H NAMELIST ITEM IS NOT A VARIABLE,32)
      GO TO 80
   30 CALL ERROR1(37H ILLEGAL SYNTAX - EXPECTED IDENTIFIER,37)
      GO TO 80
   40 CALL ERROR1(32H ILLEGAL SYNTAX - EXPECTED SLASH,32)
      GO TO 80
   50 CALL ERROR1(40H ILLEGAL SYNTAX - EXPECTED NAMELIST NAME,40)
      GO TO 80
   60 CALL ERROR1(32H ILLEGAL SYNTAX - EXPECTED COMMA,32)
      GO TO 80
   70 IF (N .NE. 15) CALL ERROR1(
     X     45H ILLEGAL NAMELIST NAME - NAME USED PREVIOUSLY,45)
      IF (N .EQ. 15) CALL ERROR1(29H DUPLICATE NAMELIST STATEMENT,29)
   80 RETURN
      END
